---------------------
PatchSet 9698 
Date: 2007/07/02 07:36:51
Author: amosjeffries
Branch: ipv6
Tag: (none) 
Log:
Rollback Jan2007 patch from Husni. Newer one available now.

Members: 
	include/rfc1035.h:1.3.6.7->1.3.6.8 
	include/util.h:1.4.4.6->1.4.4.7 
	lib/rfc1035.c:1.4.6.10->1.4.6.11 
	lib/safe_inet_addr.c:1.2.6.6->1.2.6.7 
	src/HttpRequest.c:1.3.6.5->1.3.6.6 
	src/access_log.c:1.5.2.10->1.5.2.11 
	src/acl.c:1.4.6.18->1.4.6.19 
	src/asn.c:1.4.4.7->1.4.4.8 
	src/authenticate.c:1.4.6.10->1.4.6.11 
	src/cache_cf.c:1.4.2.13->1.4.2.14 
	src/cf.data.pre:1.4.6.8->1.4.6.9 
	src/cf_gen.c:1.3.6.5->1.3.6.6 
	src/client_db.c:1.4.6.6->1.4.6.7 
	src/client_side.c:1.7.2.12->1.7.2.13 
	src/comm.c:1.4.6.11->1.4.6.12 
	src/comm_generic.c:1.8.14.3->1.8.14.4 
	src/defines.h:1.3.6.10->1.3.6.11 
	src/delay_pools.c:1.3.6.5->1.3.6.6 
	src/dns_internal.c:1.5.6.9->1.5.6.10 
	src/errorpage.c:1.5.2.8->1.5.2.9 
	src/external_acl.c:1.12.2.3->1.12.2.4 
	src/forward.c:1.4.6.9->1.4.6.10 
	src/fqdncache.c:1.4.6.7->1.4.6.8 
	src/ftp.c:1.5.2.9->1.5.2.10 
	src/globals.h:1.4.4.7->1.4.4.8 
	src/http.c:1.5.2.7->1.5.2.8 
	src/icp_v2.c:1.3.6.7->1.3.6.8 
	src/icp_v3.c:1.3.6.4->1.3.6.5 
	src/ident.c:1.4.6.6->1.4.6.7 
	src/internal.c:1.5.2.4->1.5.2.5 
	src/ipc.c:1.3.6.5->1.3.6.6 
	src/ipcache.c:1.4.6.14->1.4.6.15 
	src/main.c:1.5.4.8->1.5.4.9 
	src/multicast.c:1.3.6.5->1.3.6.6 
	src/neighbors.c:1.5.4.10->1.5.4.11 
	src/net_db.c:1.6.2.7->1.6.2.8 
	src/pconn.c:1.4.6.5->1.4.6.6 
	src/peer_select.c:1.3.6.8->1.3.6.9 
	src/peer_sourcehash.c:1.3.42.3->1.3.42.4 
	src/protos.h:1.5.2.14->1.5.2.15 
	src/redirect.c:1.3.6.6->1.3.6.7 
	src/send-announce.c:1.3.6.5->1.3.6.6 
	src/snmp_agent.c:1.3.6.5->1.3.6.6 
	src/snmp_core.c:1.3.6.9->1.3.6.10 
	src/ssl.c:1.3.6.9->1.3.6.10 
	src/stat.c:1.4.6.7->1.4.6.8 
	src/structs.h:1.7.2.12->1.7.2.13 
	src/tools.c:1.4.2.12->1.4.2.13 
	src/typedefs.h:1.4.2.7->1.4.2.8 
	src/url.c:1.3.6.7->1.3.6.8 
	src/wccp.c:1.3.6.5->1.3.6.6 
	src/wccp2.c:1.28.2.3->1.28.2.4 
	src/auth/digest/auth_digest.c:1.4.12.6->1.4.12.7 

Index: squid/include/rfc1035.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/rfc1035.h,v
retrieving revision 1.3.6.7
retrieving revision 1.3.6.8
diff -u -r1.3.6.7 -r1.3.6.8
--- squid/include/rfc1035.h	1 Jul 2007 05:46:09 -0000	1.3.6.7
+++ squid/include/rfc1035.h	2 Jul 2007 07:36:51 -0000	1.3.6.8
@@ -1,5 +1,5 @@
 /*
- * $Id: rfc1035.h,v 1.3.6.7 2007/07/01 05:46:09 amosjeffries Exp $
+ * $Id: rfc1035.h,v 1.3.6.8 2007/07/02 07:36:51 amosjeffries Exp $
  *
  * AUTHOR: Duane Wessels
  *
@@ -38,9 +38,6 @@
 #if HAVE_SYS_TYPES_H
 #include <sys/types.h>
 #endif
-#if HAVE_SYS_SOCKET_H
-#include <sys/socket.h>
-#endif
 #if HAVE_NETINET_IN_H
 #include <netinet/in.h>
 #endif
@@ -74,7 +71,6 @@
     unsigned int tc:1;
     unsigned int rd:1;
     unsigned int ra:1;
-    unsigned int z:3;
     unsigned int rcode:4;
     unsigned short qdcount;
     unsigned short ancount;
@@ -89,12 +85,7 @@
     size_t sz,
     unsigned short qid,
     rfc1035_query * query);
-extern ssize_t rfc1035BuildAAAAQuery(const char *hostname,
-    char *buf,
-    size_t sz,
-    unsigned short qid,
-    rfc1035_query * query);
-extern ssize_t rfc1035BuildPTRQuery(const struct sockaddr *,
+extern ssize_t rfc1035BuildPTRQuery(const struct in_addr,
     char *buf,
     size_t sz,
     unsigned short qid,
@@ -109,7 +100,6 @@
 extern const char *rfc1035_error_message;
 
 #define RFC1035_TYPE_A 1
-#define RFC1035_TYPE_AAAA 28
 #define RFC1035_TYPE_CNAME 5
 #define RFC1035_TYPE_PTR 12
 #define RFC1035_CLASS_IN 1
Index: squid/include/util.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/util.h,v
retrieving revision 1.4.4.6
retrieving revision 1.4.4.7
diff -u -r1.4.4.6 -r1.4.4.7
--- squid/include/util.h	1 Jul 2007 05:46:09 -0000	1.4.4.6
+++ squid/include/util.h	2 Jul 2007 07:36:51 -0000	1.4.4.7
@@ -1,5 +1,5 @@
 /*
- * $Id: util.h,v 1.4.4.6 2007/07/01 05:46:09 amosjeffries Exp $
+ * $Id: util.h,v 1.4.4.7 2007/07/02 07:36:51 amosjeffries Exp $
  *
  * AUTHOR: Harvest Derived
  *
@@ -104,7 +104,7 @@
 extern void xmalloc_find_leaks(void);
 #endif
 
-typedef struct sockaddr SIA;
+typedef struct in_addr SIA;
 extern int safe_inet_addr(const char *, SIA *);
 extern time_t parse_iso3307_time(const char *buf);
 extern char *base64_decode(const char *coded);
Index: squid/lib/rfc1035.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/rfc1035.c,v
retrieving revision 1.4.6.10
retrieving revision 1.4.6.11
diff -u -r1.4.6.10 -r1.4.6.11
--- squid/lib/rfc1035.c	1 Jul 2007 05:46:09 -0000	1.4.6.10
+++ squid/lib/rfc1035.c	2 Jul 2007 07:36:51 -0000	1.4.6.11
@@ -1,6 +1,6 @@
 
 /*
- * $Id: rfc1035.c,v 1.4.6.10 2007/07/01 05:46:09 amosjeffries Exp $
+ * $Id: rfc1035.c,v 1.4.6.11 2007/07/02 07:36:51 amosjeffries Exp $
  *
  * Low level DNS protocol routines
  * AUTHOR: Duane Wessels
@@ -644,7 +644,7 @@
     h.qr = 0;
     h.rd = 1;
     h.opcode = 0;		/* QUERY */
-    h.qdcount = 1; 
+    h.qdcount = (unsigned int) 1;
     offset += rfc1035HeaderPack(buf + offset, sz - offset, &h);
     offset += rfc1035QuestionPack(buf + offset,
 	sz - offset,
@@ -660,32 +660,6 @@
     return offset;
 }
 
-ssize_t
-rfc1035BuildAAAAQuery(const char *hostname, char *buf, size_t sz, unsigned short qid, rfc1035_query * query)
-{
-    static rfc1035_message h;
-    size_t offset = 0;
-    memset(&h, '\0', sizeof(h));
-    h.id = qid;
-    h.qr = 0;
-    h.rd = 1;
-    h.opcode = 0;		/* QUERY */
-    h.qdcount = 1;
-    offset += rfc1035HeaderPack(buf + offset, sz - offset, &h);
-    offset += rfc1035QuestionPack(buf + offset,
-	sz - offset,
-	hostname,
-	RFC1035_TYPE_AAAA,
-	RFC1035_CLASS_IN);
-    if (query) {
-	query->qtype = RFC1035_TYPE_AAAA;
-	query->qclass = RFC1035_CLASS_IN;
-	xstrncpy(query->name, hostname, sizeof(query->name));
-    }
-    assert(offset <= sz);
-    return offset;
-}
-
 /*
  * rfc1035BuildPTRQuery()
  * 
@@ -697,45 +671,19 @@
  * Returns the size of the query
  */
 ssize_t
-rfc1035BuildPTRQuery(const struct sockaddr *addr, char *buf, size_t sz, unsigned short qid, rfc1035_query * query)
+rfc1035BuildPTRQuery(const struct in_addr addr, char *buf, size_t sz, unsigned short qid, rfc1035_query * query)
 {
     static rfc1035_message h;
     size_t offset = 0;
-    static char rev[100];
+    static char rev[32];
     unsigned int i;
     memset(&h, '\0', sizeof(h));
-    memset(rev, '\0', sizeof(rev));
-    if (addr->sa_family == AF_INET) {
-    i = (unsigned int) ntohl(((struct sockaddr_in *)addr)->sin_addr.s_addr);
+    i = (unsigned int) ntohl(addr.s_addr);
     snprintf(rev, 32, "%u.%u.%u.%u.in-addr.arpa.",
 	i & 255,
 	(i >> 8) & 255,
 	(i >> 16) & 255,
 	(i >> 24) & 255);
-    }
-    if (addr->sa_family == AF_INET6) {
-	char temp[16];
-	int sx, ex;
-	u_int8_t ci;
-#if BYTE_ORDER == BIG_ENDIAN
-	sx = 0;
-#elif BYTE_ORDER == LITTLE_ENDIAN
-	sx = 15;
-#endif
-	for (i = 0; i < 16; i++) {
-	    ci = ((struct sockaddr_in6 *)addr)->sin6_addr.s6_addr[sx];
-	    memset(temp, '\0', sizeof(temp));
-	    sprintf(temp, "%x.%x", ci & 0xf, ci & 0xf0);
-	    strcat(rev, temp);
-#if BYTE_ORDER == BIG_ENDIAN
-	    sx++;
-#elif BYTE_ORDER == LITTLE_ENDIAN
-	    sx--;
-#endif
-
-	}
-	strcat(rev, ".ip6.arpa");
-    }
     h.id = qid;
     h.qr = 0;
     h.rd = 1;
Index: squid/lib/safe_inet_addr.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/safe_inet_addr.c,v
retrieving revision 1.2.6.6
retrieving revision 1.2.6.7
diff -u -r1.2.6.6 -r1.2.6.7
--- squid/lib/safe_inet_addr.c	1 Jul 2007 05:46:09 -0000	1.2.6.6
+++ squid/lib/safe_inet_addr.c	2 Jul 2007 07:36:51 -0000	1.2.6.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: safe_inet_addr.c,v 1.2.6.6 2007/07/01 05:46:09 amosjeffries Exp $
+ * $Id: safe_inet_addr.c,v 1.2.6.7 2007/07/02 07:36:51 amosjeffries Exp $
  */
 
 #include "config.h"
@@ -24,9 +24,6 @@
 #if HAVE_NETINET_IN_H
 #include <netinet/in.h>
 #endif
-#if HAVE_NETDB_H
-#include <netdb.h>
-#endif
 #if HAVE_ARPA_INET_H
 #include <arpa/inet.h>
 #endif
@@ -34,18 +31,36 @@
 #include "snprintf.h"
 
 int
-safe_inet_addr(const char *buf, struct sockaddr *addr)
+safe_inet_addr(const char *buf, struct in_addr *addr)
 {
-    struct addrinfo hints, *res;
-    int error;
-
-    memset(&hints, 0, sizeof(hints));
-    hints.ai_flags = AI_NUMERICHOST|AI_PASSIVE;
-    hints.ai_family = PF_UNSPEC;
-    error = getaddrinfo(buf, NULL, &hints, &res);
-    if (error) return 0;
-    xmemcpy(addr, res->ai_addr, res->ai_addrlen);
-    freeaddrinfo(res);
+    static char addrbuf[32];
+    int a1 = 0, a2 = 0, a3 = 0, a4 = 0;
+    struct in_addr A;
+    char x;
+#if defined(_SQUID_HPUX_)
+    /*
+     * MIYOSHI Tsutomu <mijosxi@ike.tottori-u.ac.jp> says scanning 'buf'
+     * causes a bus error on hppa1.1-hp-hpux9.07, so we
+     * have a broad hack for all HP systems.
+     */
+    static char buftmp[32];
+    snprintf(buftmp, 32, "%s", buf);
+    if (sscanf(buftmp, "%d.%d.%d.%d%c", &a1, &a2, &a3, &a4, &x) != 4)
+#else
+    if (sscanf(buf, "%d.%d.%d.%d%c", &a1, &a2, &a3, &a4, &x) != 4)
+#endif
+	return 0;
+    if (a1 < 0 || a1 > 255)
+	return 0;
+    if (a2 < 0 || a2 > 255)
+	return 0;
+    if (a3 < 0 || a3 > 255)
+	return 0;
+    if (a4 < 0 || a4 > 255)
+	return 0;
+    snprintf(addrbuf, 32, "%d.%d.%d.%d", a1, a2, a3, a4);
+    A.s_addr = inet_addr(addrbuf);
+    if (addr)
+	addr->s_addr = A.s_addr;
     return 1;
-
 }
Index: squid/src/HttpRequest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpRequest.c,v
retrieving revision 1.3.6.5
retrieving revision 1.3.6.6
diff -u -r1.3.6.5 -r1.3.6.6
--- squid/src/HttpRequest.c	1 Jul 2007 05:44:17 -0000	1.3.6.5
+++ squid/src/HttpRequest.c	2 Jul 2007 07:36:51 -0000	1.3.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpRequest.c,v 1.3.6.5 2007/07/01 05:44:17 amosjeffries Exp $
+ * $Id: HttpRequest.c,v 1.3.6.6 2007/07/02 07:36:51 amosjeffries Exp $
  *
  * DEBUG: section 73    HTTP Request
  * AUTHOR: Duane Wessels
@@ -45,8 +45,8 @@
 	stringReset(&req->urlpath, urlpath);
     req->max_forwards = -1;
     req->lastmod = -1;
-    memset(&req->client_addr, 0, sizeof(req->client_addr));
-    memset(&req->my_addr, 0, sizeof(req->client_addr));
+    req->client_addr = no_addr;
+    req->my_addr = no_addr;
     httpHeaderInit(&req->header, hoRequest);
     return req;
 }
@@ -126,8 +126,8 @@
 {
     assert(req && p);
     /* Client info */
-    packerPrintf(p, "Client: %s ", sockaddr_ntoa(&req->client_addr));
-    packerPrintf(p, "http_port: %s:%d", sockaddr_ntoa(&req->my_addr), req->my_port);
+    packerPrintf(p, "Client: %s ", inet_ntoa(req->client_addr));
+    packerPrintf(p, "http_port: %s:%d", inet_ntoa(req->my_addr), req->my_port);
     if (req->auth_user_request && authenticateUserRequestUsername(req->auth_user_request))
 	packerPrintf(p, "user: %s", authenticateUserRequestUsername(req->auth_user_request));
     packerPrintf(p, "\n");
Index: squid/src/access_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/access_log.c,v
retrieving revision 1.5.2.10
retrieving revision 1.5.2.11
diff -u -r1.5.2.10 -r1.5.2.11
--- squid/src/access_log.c	1 Jul 2007 08:34:22 -0000	1.5.2.10
+++ squid/src/access_log.c	2 Jul 2007 07:36:51 -0000	1.5.2.11
@@ -1,6 +1,6 @@
 
 /*
- * $Id: access_log.c,v 1.5.2.10 2007/07/01 08:34:22 amosjeffries Exp $
+ * $Id: access_log.c,v 1.5.2.11 2007/07/02 07:36:51 amosjeffries Exp $
  *
  * DEBUG: section 46    Access Log
  * AUTHOR: Duane Wessels
@@ -449,7 +449,6 @@
 	long int outint = 0;
 	int doint = 0;
 	int dofree = 0;
-	char caddr[80];
 	switch (fmt->type) {
 	case LFT_NONE:
 	    out = "";
@@ -458,18 +457,13 @@
 	    out = fmt->data.string;
 	    break;
 	case LFT_CLIENT_IP_ADDRESS:
-	    getnameinfo((struct sockaddr *)&al->cache.caddr, SOCKLEN(&al->cache.caddr), caddr, 80,
-		(char *)NULL, 0, NI_NUMERICHOST);
-	    out = caddr;
+	    out = inet_ntoa(al->cache.caddr);
 	    break;
 
 	case LFT_CLIENT_FQDN:
-	    out = fqdncache_gethostbyaddr((struct sockaddr *)&al->cache.caddr, FQDN_LOOKUP_IF_MISS);
-	    if (!out) {
-		getnameinfo((struct sockaddr *)&al->cache.caddr, SOCKLEN(&al->cache.caddr), caddr, 80,
-		(char *)NULL, 0, NI_NUMERICHOST);
-		out = caddr;
-	    }
+	    out = fqdncache_gethostbyaddr(al->cache.caddr, FQDN_LOOKUP_IF_MISS);
+	    if (!out)
+		out = inet_ntoa(al->cache.caddr);
 	    break;
 
 	case LFT_CLIENT_PORT:
@@ -485,18 +479,14 @@
 	    out = al->hier.host;
 	    break;
 	case LFT_OUTGOING_IP:
-	    out = xstrdup(sockaddr_ntoa(&al->cache.out_ip));
+	    out = xstrdup(inet_ntoa(al->cache.out_ip));
 	    break;
 
 	    /* case LFT_SERVER_PORT: */
 
 	case LFT_LOCAL_IP:
-	    if (al->request) {
-		getnameinfo((struct sockaddr *)&al->request->my_addr, 
-		    SOCKLEN(&al->request->my_addr), 
-		    caddr, 80, (char *)NULL, 0, NI_NUMERICHOST);
-		out = caddr;
-	    }
+	    if (al->request)
+		out = inet_ntoa(al->request->my_addr);
 	    break;
 
 	case LFT_LOCAL_PORT:
@@ -1032,14 +1022,10 @@
 {
     const char *client = NULL;
     const char *user = NULL;
-    char caddr[80];
     if (Config.onoff.log_fqdn)
-	client = fqdncache_gethostbyaddr((struct sockaddr *)&al->cache.caddr, FQDN_LOOKUP_IF_MISS);
-    if (client == NULL) {
-	getnameinfo((struct sockaddr *)&al->cache.caddr, SOCKLEN(&al->cache.caddr), caddr, 80,
-		(char *)NULL, 0, NI_NUMERICHOST);
-	client = caddr;
-    }
+	client = fqdncache_gethostbyaddr(al->cache.caddr, FQDN_LOOKUP_IF_MISS);
+    if (client == NULL)
+	client = inet_ntoa(al->cache.caddr);
     user = accessLogFormatName(al->cache.authuser);
     if (!user)
 	user = accessLogFormatName(al->cache.rfc931);
@@ -1096,14 +1082,10 @@
 {
     const char *client = NULL;
     char *user1 = NULL, *user2 = NULL;
-    char caddr[80];
     if (Config.onoff.log_fqdn)
-	client = fqdncache_gethostbyaddr((struct sockaddr *)&al->cache.caddr, FQDN_LOOKUP_IF_MISS);
-    if (client == NULL) {
-	getnameinfo((struct sockaddr *)&al->cache.caddr, SOCKLEN(&al->cache.caddr), caddr, 80,
-		(char *)NULL, 0, NI_NUMERICHOST);
-	client = caddr;
-    }
+	client = fqdncache_gethostbyaddr(al->cache.caddr, 0);
+    if (client == NULL)
+	client = inet_ntoa(al->cache.caddr);
     user1 = accessLogFormatName(al->cache.authuser);
     user2 = accessLogFormatName(al->cache.rfc931);
     logfilePrintf(logfile, "%s %s %s [%s] \"%s %s HTTP/%d.%d\" %d %" PRINTF_OFF_T " %s:%s",
